summaryrefslogtreecommitdiff
path: root/tests/cp/special-f
diff options
context:
space:
mode:
authorJim Meyering <meyering@redhat.com>2008-04-02 15:07:20 +0200
committerJim Meyering <meyering@redhat.com>2008-04-02 18:23:04 +0200
commitc1b6f9458a55cdc1143a1ae3959c577004ff8e3f (patch)
treeb0327fc56e3bbfa959e34b65576895f97f121428 /tests/cp/special-f
parentf3653f0d204a07d80444c261126360901b849e37 (diff)
downloadcoreutils-c1b6f9458a55cdc1143a1ae3959c577004ff8e3f.tar.xz
"touch E; mkfifo F; cp -fR F E" no longer fails due to existing E
* src/copy.c (copy_internal): Revert change of 2005-03-01, 4303f0454592421eea48be87777d32a49e1d5e5b Prompted by Michael Stone, who pointed me to an old bug report from Ian Jackson: http://thread.gmane.org/gmane.comp.gnu.coreutils.bugs/7504 * tests/cp/special-f: New file. Test for the above. * tests/cp/Makefile.am (TESTS): Add special-f. * NEWS: mention this bug fix.
Diffstat (limited to 'tests/cp/special-f')
-rwxr-xr-xtests/cp/special-f42
1 files changed, 42 insertions, 0 deletions
diff --git a/tests/cp/special-f b/tests/cp/special-f
new file mode 100755
index 000000000..ebcbf8ea3
--- /dev/null
+++ b/tests/cp/special-f
@@ -0,0 +1,42 @@
+#!/bin/sh
+# Ensure that "cp -Rf fifo E" unlinks E and retries.
+# Up until coreutils-6.10.171, it would not.
+
+# Copyright (C) 2008 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+if test "$VERBOSE" = yes; then
+ set -x
+ cp --version
+fi
+
+. $srcdir/../envvar-check
+. $srcdir/../lang-default
+. $srcdir/../test-lib.sh
+
+mkfifo fifo ||
+ skip_test_ "fifos not supported"
+touch e || framework-failure
+
+fail=0
+
+# Without -f, expect it to fail.
+cp -R fifo e || fail=1
+
+# With -f, it must succeed.
+cp -Rf fifo e || fail=1
+test -p fifo || fail=1
+
+(exit $fail); exit $fail